(* test for sml/ME/mathengine.sml
   authors: Walther Neuper 2000, 2006
   (c) due to copyright terms

use"../smltest/ME/mathengine.sml";
use"mathengine.sml";
*)

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- debugging setContext..pbl_ --------------------------";
"----------- tryrefine -------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";



"----------- debugging setContext..pbl_ --------------------------";
"----------- debugging setContext..pbl_ --------------------------";
"----------- debugging setContext..pbl_ --------------------------";
states:=[];
CalcTree
[(["equality (x+1=2)", "solveFor x","solutions L"], 
  ("Test.thy", 
   ["sqroot-test","univariate","equation","test"],
   ["Test","squ-equ-test-subpbl1"]))];
Iterator 1;
moveActiveRoot 1; modelProblem 1;

val pos as (p,_) = ([],Pbl);
val guh = "pbl_equ_univ";
checkContext 1 pos guh;
val ((pt,_),_) = get_calc 1;
val pp = par_pblobj pt p;
val keID = guh2kestoreID guh;
case context_pbl keID pt pp of (true,["univariate", "equation"],_,_,_)=>()
| _ => raise error "mathengine.sml: context_pbl .. pbl_equ_univ checked";

case get_obj g_spec pt p of (_, ["e_pblID"], _) => ()
| _ => raise error "mathengine.sml: context_pbl .. pbl still empty";
setContext 1 pos guh;
val ((pt,_),_) = get_calc 1;
case get_obj g_spec pt p of (_, ["univariate", "equation"], _) => ()
| _ => raise error "mathengine.sml: context_pbl .. pbl set";


setContext 1 pos "met_eq_lin";
val ((pt,_),_) = get_calc 1;
case get_obj g_spec pt p of (_,  _, ["LinEq", "solve_lineq_equation"]) => ()
| _ => raise error "mathengine.sml: context_pbl .. pbl set";


"----------- tryrefine -------------------------------------------";
"----------- tryrefine -------------------------------------------";
"----------- tryrefine -------------------------------------------";
states:=[];
CalcTree [(["equality (x/(x^2 - 6*x+9) - 1/(x^2 - 3*x) =1/x)", 
	    "solveFor x", "solutions L"],
	   ("RatEq.thy",["univariate","equation"],["no_met"]))];
Iterator 1;
moveActiveRoot 1; autoCalculate 1 CompleteCalc;

refineProblem 1 ([1],Res) "pbl_equ_univ" 
(*gives "pbl_equ_univ_rat" correct*);

refineProblem 1 ([1],Res) (pblID2guh ["linear","univariate","equation"])
(*ives "pbl_equ_univ_lin" incorrect*);
